
stages:
  - build
 
.build_and_publish:
  image:
    name: gcr.io/kaniko-project/executor:debug
    entrypoint: [""]
  rules:
    - if: $CI_COMMIT_BRANCH == "main"
      #variables: 
      #  IMAGE_TAG: "latest"
      changes:
        - ${SUB_PATH}/**/*
    - if: $CI_MERGE_REQUEST_IID
      variables:
        IMAGE_TAG: "${CI_COMMIT_REF_SLUG}"
      changes:
        - ${SUB_PATH}/**/*
  variables:
    JSON_CONFIG: |
      {
        "auths": {
          "$CI_REGISTRY": {
            "username": "$CI_REGISTRY_USER",
            "password": "$CI_REGISTRY_PASSWORD"
          }
        }
      }
  script: |
    if [[ $CI_COMMIT_BRANCH = "main" ]]; then
      set -o allexport; source ${SUB_PATH}/.env; set +o allexport
      echo "😛 ${IMAGE_TAG}"
    else 
      echo "🦊"
    fi
    echo "${JSON_CONFIG}" > /kaniko/.docker/config.json
    /kaniko/executor \
      --context $CI_PROJECT_DIR/$SUB_PATH \
      --dockerfile $CI_PROJECT_DIR/$SUB_PATH/Dockerfile \
      --cache=true \
      --destination $CI_REGISTRY_IMAGE/$SUB_PATH:$IMAGE_TAG


build git-quick-stats:
  stage: build
  image: !reference [.build_and_publish, image]
  variables: 
    JSON_CONFIG: !reference [.build_and_publish, variables, JSON_CONFIG]
    SUB_PATH: "git-quick-stats"
  rules: !reference [.build_and_publish, rules]
  script: !reference [.build_and_publish, script]

build gitleaks:
  stage: build
  image: !reference [.build_and_publish, image]
  variables: 
    JSON_CONFIG: !reference [.build_and_publish, variables, JSON_CONFIG]
    SUB_PATH: "gitleaks"
  rules: !reference [.build_and_publish, rules]
  script: !reference [.build_and_publish, script]

build semgrep:
  stage: build
  image: !reference [.build_and_publish, image]
  variables: 
    JSON_CONFIG: !reference [.build_and_publish, variables, JSON_CONFIG]
    SUB_PATH: "semgrep"
  rules: !reference [.build_and_publish, rules]
  script: !reference [.build_and_publish, script]


